#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <gtk/gtk.h>
#include "gtkpanda.h"


extern	void	*
_xmalloc(
	size_t	size,
	char	*fn,
	int		line)
{
	return	(malloc(size));
}
extern	void
_xfree(
	void	*p,
	char	*fn,
	int		line)
{
	free(p);
}

static void
on_clist1_click_column                 (GtkCList        *clist,
                                        gint             column,
                                        gpointer         user_data)
{
    printf("on_clist1_click_column(): column %d\n", column);
}


static void
on_clist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
    printf("on_clist1_select_row: row %d, column %d\n", row, column);
}

static void
on_clist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
    printf("on_clist1_unselect_row: row %d, column %d\n", row, column);
}

static void
on_window1_select_row (GtkWidget	*w,
		       gint             row,
		       gint             column,
		       GdkEvent        *event,
		       GtkCList        *clist,
		       gpointer         user_data)
{
    printf("on_window1_select_row: clist %08x, row %d, column %d\n",
	   (int)clist, row, column);
}

static void
on_window1_unselect_row (GtkWidget	*w,
		       gint             row,
		       gint             column,
		       GdkEvent        *event,
		       GtkCList        *clist,
		       gpointer         user_data)
{
    printf("on_window1_unselect_row: clist %08x, row %d, column %d\n",
	   (int)clist, row, column);
}


static void
on_clist1_row_move                 (GtkCList        *clist,
                                        gint             arg1,
                                        gint             arg2,
                                        gpointer         user_data)
{
    printf("on_clist1_row_move: arg1 %d, arg2 %d\n",
	   arg1, arg2);
}

#define TESTGTK_CLIST_COLUMNS 5

int
main (int argc, char *argv[])
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *clist1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  int i;
  static char text[TESTGTK_CLIST_COLUMNS][50];
  static char *texts[TESTGTK_CLIST_COLUMNS];

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  gtkpanda_init (&argc, &argv);

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_show (window1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);

  clist1 = gtkpanda_clist_new (3);
  gtk_widget_ref (clist1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "clist1", clist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist1);
  gtkpanda_clist_set_column_width (GTK_PANDA_CLIST (clist1), 0, 80);
  gtkpanda_clist_set_column_width (GTK_PANDA_CLIST (clist1), 1, 80);
  gtkpanda_clist_set_column_width (GTK_PANDA_CLIST (clist1), 2, 80);
  gtkpanda_clist_column_titles_show (GTK_PANDA_CLIST (clist1));
  gtkpanda_clist_set_shadow_type (GTK_PANDA_CLIST (clist1), GTK_SHADOW_OUT);



  label2 = gtk_label_new ("label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtkpanda_clist_set_column_widget (GTK_PANDA_CLIST (clist1), 0, label2);

  label3 = gtk_label_new ("label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtkpanda_clist_set_column_widget (GTK_PANDA_CLIST (clist1), 1, label3);

  label4 = gtk_label_new ("label4");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (window1), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtkpanda_clist_set_column_widget (GTK_PANDA_CLIST (clist1), 2, label4);

#if 1
  gtkpanda_clist_set_selection_mode (GTK_PANDA_CLIST (clist1),
				  GTK_SELECTION_SINGLE);
#else
  gtkpanda_clist_set_selection_mode (GTK_PANDA_CLIST (clist1),
				  GTK_SELECTION_EXTENDED);
#endif

  for (i = 0; i < TESTGTK_CLIST_COLUMNS; i++){
      texts[i] = text[i];
      sprintf (text[i], "Column %d", i);
  }

  for (i = 0; i < 10; i++){
      sprintf (text[0], "CListRow %d", i);
      gtkpanda_clist_append (GTK_PANDA_CLIST (clist1), texts);
  }


  gtk_signal_connect (GTK_OBJECT (clist1), "click-column",
                      GTK_SIGNAL_FUNC (on_clist1_click_column),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clist1), "select-row",
                      GTK_SIGNAL_FUNC (on_clist1_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clist1), "unselect-row",
                      GTK_SIGNAL_FUNC (on_clist1_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (clist1), "row-move",
                      GTK_SIGNAL_FUNC (on_clist1_row_move),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (window1), "gtkpanda_clist_select_row",
                      GTK_SIGNAL_FUNC (on_window1_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (window1), "gtkpanda_clist_unselect_row",
                      GTK_SIGNAL_FUNC (on_window1_unselect_row),
                      NULL);

  gtk_main ();
  return 0;
}

