#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <numeric.h>
#include "gtkpanda.h"
#include "gtkpandahtml.h"
#include "debug.h"

#include <gtk-xmhtml/gtk-xmhtml.h>

extern	void	*
_xmalloc(
	size_t	size,
	char	*fn,
	int		line)
{
	return	(malloc(size));
}
extern	void
_xfree(
	void	*p,
	char	*fn,
	int		line)
{
	free(p);
}

void
open_browser (GtkPandaHTML *html, XmHTMLAnchorCallbackStruct *cbs, void *data)
{
  /* build target URI */
  char uri[FILENAME_MAX];
  if (strncmp (cbs->href, "http:", 5) == 0)
    {
      /* full URI */
      strcpy (uri, cbs->href);
    }
  else
    {
      strcpy (uri, gtk_panda_html_get_uri (html));
      if (cbs->href[0] == '/')
	{
	  /* absolute path */
	  char *p = strchr (uri + 7, '/');
	  if (p)
	    strcpy (p + 1, cbs->href + 1);
	  else
	    strcat (uri, cbs->href);
	}
      else
	{
	  /* relative path */
	  char *p = strrchr (uri, '/');
	  if (p)
	    strcpy (p + 1, cbs->href);
	  else
	    {
	      strcat (uri, "/");
	      strcat (uri, cbs->href);
	    }
	}
    }

  /* open */
  if (!cbs->target)
    gtk_panda_html_set_uri (html, uri);
  else
    {
      char buff[256];
      sprintf (buff, "gnome-moz-remote %s", uri);
      system (buff);
    }
}

static GtkWidget *
create_window1 (char *uri)
{
  GtkWidget *window1;
  GtkWidget *html1;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "window1");

  html1 = gtk_panda_html_new ();
  gtk_panda_html_set_uri (GTK_PANDA_HTML (html1), uri);
  gtk_widget_show (html1);
  gtk_container_add (GTK_CONTAINER (window1), html1);

  gtk_signal_connect (GTK_OBJECT (html1), "activate",
		      GTK_SIGNAL_FUNC (open_browser), NULL);

  return window1;
}

int
main (int argc, char **argv)
{
  GtkWidget *window;

  if (argc != 2)
    {
      puts ("Usage: testhtml uri");
      exit (1);
    }

#ifdef ENABLE_GNOME
  gnome_init ("test", VERSION, argc, argv);
#else
  gtk_set_locale ();
  gtk_init (&argc, &argv);
#endif

  window = create_window1 (argv[1]);
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
		      GTK_SIGNAL_FUNC (gtk_main_quit), NULL);

  gtk_widget_show (window);
  gtk_main ();

  return 0;
}
