/*
#define	DEBUG
#define	TRACE
*/
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <numeric.h>
#include "gtkpanda.h"
#include "debug.h"

extern	void	*
_xmalloc(
	size_t	size,
	char	*fn,
	int		line)
{
	return	(malloc(size));
}
extern	void
_xfree(
	void	*p,
	char	*fn,
	int		line)
{
	free(p);
}

extern	void
print_value(
	GtkNumberEntry	*entry,
	gpointer		user_data)
{
	Numeric	value;
	char	*str;

	value = gtk_number_entry_get_value(entry);
	str =  NumericOutput(value);
	printf("[%s]\n",str);
	NumericFree(value);
	free(str);
}

extern	int
main(
	int		argc,
	char	**argv)
{
	GtkWidget	*window;
	GtkWidget	*entry;
	GtkStyle	*st
	,			*dst;
	Numeric		value;

#ifdef ENABLE_GNOME
	gnome_init("test", VERSION, argc, argv);
#else
	gtk_set_locale();
	gtk_init(&argc, &argv);
#endif

	dst = gtk_widget_get_default_style();
	st = gtk_style_copy(dst);
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	gtk_signal_connect(GTK_OBJECT(window),"destroy",
					   GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
	entry = gtk_number_entry_new_with_format("----,--9.99");
	gtk_signal_connect(GTK_OBJECT(entry),"activate",
					   GTK_SIGNAL_FUNC(print_value), NULL);
	value = NumericInput(argv[1],9,0);
dbgmsg("*");
	gtk_number_entry_set_value(GTK_NUMBER_ENTRY(entry),value);
	NumericFree(value);
dbgmsg("**");

	gtk_container_add(GTK_CONTAINER(window),entry);
dbgmsg("***");

	gtk_widget_show(entry);
dbgmsg("****");
	gtk_widget_show(window);
dbgmsg("*****");
	st->fg[GTK_STATE_NORMAL].red = 0xffff;
	st->fg[GTK_STATE_NORMAL].green = 0x0000;
	st->fg[GTK_STATE_NORMAL].blue = 0x0000;
	gtk_widget_set_style(entry,st);

	gtk_main();

	return	0;
}
