#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <gtk/gtk.h>
#include "gtkpanda.h"


extern	void	*
_xmalloc(
	size_t	size,
	char	*fn,
	int		line)
{
	return	(malloc(size));
}
extern	void
_xfree(
	void	*p,
	char	*fn,
	int		line)
{
	free(p);
}

void
on_tree1_select_child                  (GtkPandaTree         *tree,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
    printf("on_tree1_select_child(): \n");

}

static void
print_selection_tree(GList *selection)
{
    GtkPandaTreeItem *item;
    GList *children;

    printf(" selected item:\n");
    while(selection){
	item = GTK_PANDA_TREE_ITEM (selection->data);
	printf("   GtkPandaTreeItem 0x%08x\n", (int)item);
	children = gtk_container_children( GTK_CONTAINER (item) );
	
	selection = selection->next;
    }
}

void
on_tree1_selection_changed             (GtkPandaTree         *tree,
                                        gpointer         user_data)
{
    printf("on_tree1_selection_changed(): \n");
    print_selection_tree( tree->selection);
    
}

void
on_window1_selection_changed (GtkContainer *c, GtkPandaTree *tree,
			      gpointer user_data)
{
    printf("on_window1_selection_changed(): tree=%08x\n", (int)tree);
    print_selection_tree( tree->selection);
}


void
on_tree1_unselect_child                (GtkPandaTree         *tree,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
    printf("on_tree1_unselect_child(): \n");

}

void
on_tree1_item_select                (GtkItem *item,
                                        gpointer         user_data)
{
    printf("on_tree1_item_select(): 0x%08x\n", (int)item);
}

void
on_tree1_item_deselect                (GtkItem *item,
                                        gpointer         user_data)
{
    printf("on_tree1_item_deselect(): 0x%08x\n", (int)item);
}

void
tree1_item_signal_connect(GtkWidget *widget)
{
#if 0
  gtk_signal_connect (GTK_OBJECT (widget), "select",
                      GTK_SIGNAL_FUNC (on_tree1_item_select),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (widget), "deselect",
                      GTK_SIGNAL_FUNC (on_tree1_item_deselect),
                      NULL);
#endif
}

void
on_tree1_activate(GtkPandaTree *tree, gpointer user_data)
{
    printf("on_tree1_activate(): tree=%08x\n", (int)tree);
}


int
main (int argc, char *argv[])
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *tree1;

#ifdef ENABLE_NLS
  //  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  //  textdomain (PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  gtkpanda_init (&argc, &argv);

  //  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  //  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_show (window1);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  

  tree1 = gtkpanda_tree_new ();
  //  gtkpanda_tree_set_selection_mode(GTK_PANDA_TREE(tree1), GTK_SELECTION_BROWSE);
  //  gtkpanda_tree_set_selection_mode(GTK_PANDA_TREE(tree1), GTK_SELECTION_EXTENDED);
  gtk_widget_ref (tree1);
  gtk_object_set_data_full (GTK_OBJECT (window1), "tree1", tree1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tree1);
  gtk_box_pack_start (GTK_BOX (vbox1), tree1, TRUE, TRUE, 0);

  {
      GtkWidget* root_item;
      GtkWidget* item_subtree;
      GtkWidget* item_new;
      GtkWidget* item_new2;

      root_item = gtkpanda_tree_item_new_with_label("root item");
      gtkpanda_tree_append(GTK_PANDA_TREE(tree1), root_item);
      gtk_widget_show(root_item);
      tree1_item_signal_connect(root_item);
      
      item_subtree = gtkpanda_tree_new();
      item_new = gtkpanda_tree_item_new_with_label("item1");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      item_new = gtkpanda_tree_item_new_with_label("item2");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      item_new = gtkpanda_tree_item_new_with_label("item3");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      gtkpanda_tree_item_set_subtree(GTK_PANDA_TREE_ITEM(root_item), item_subtree);

      root_item = gtkpanda_tree_item_new_with_label("root item2");
      gtkpanda_tree_append(GTK_PANDA_TREE(tree1), root_item);
      gtk_widget_show(root_item);
      tree1_item_signal_connect(root_item);
      
      item_subtree = gtkpanda_tree_new();
      item_new = gtkpanda_tree_item_new_with_label("item2-1");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      item_new = gtkpanda_tree_item_new_with_label("item2-2");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      item_new = gtkpanda_tree_item_new_with_label("item2-3");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      item_new2 = item_new;
      gtkpanda_tree_item_set_subtree(GTK_PANDA_TREE_ITEM(root_item), item_subtree);


      item_subtree = gtkpanda_tree_new();
      item_new = gtkpanda_tree_item_new_with_label("item2-3-1");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      item_new = gtkpanda_tree_item_new_with_label("item2-3-2");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      item_new = gtkpanda_tree_item_new_with_label("item2-3-3");
      gtkpanda_tree_append(GTK_PANDA_TREE(item_subtree), item_new);
      gtk_widget_show(item_new);
      tree1_item_signal_connect(item_new);
      gtkpanda_tree_item_set_subtree(GTK_PANDA_TREE_ITEM(item_new2), item_subtree);
  }

  gtk_signal_connect (GTK_OBJECT (tree1), "select_child",
                      GTK_SIGNAL_FUNC (on_tree1_select_child),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tree1), "selection_changed",
                      GTK_SIGNAL_FUNC (on_tree1_selection_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tree1), "unselect_child",
                      GTK_SIGNAL_FUNC (on_tree1_unselect_child),
                      NULL);
  /*
  gtk_signal_connect (GTK_OBJECT (tree1), "activate",
                      GTK_SIGNAL_FUNC (on_tree1_activate),
                      NULL);
  */
  gtk_signal_connect (GTK_OBJECT (window1), "gtkpanda_tree_selection_changed",
                      GTK_SIGNAL_FUNC (on_window1_selection_changed),
                      NULL);

  gtk_main ();
  return 0;
}

